Add unit tests and changes related

Base unit tests have been added with the means to generate
gcov coverage information and a small amounto of coverage
data.  Some changes were made to the code to make testing
coverage better and to fix identified issues.

Most important are the unique smart ptr changes; the
framework prototypes now require them to be shared pointers
as they are not released/reallocated (e.g. message Send()).

Issue-ID: RIC-148

Signed-off-by: E. Scott Daniels <daniels@research.att.com>
Change-Id: Ibc593ddc8687ce6d727bf6d3e2939c02f1e0afef
diff --git a/build_rmr.sh b/build_rmr.sh
new file mode 100755
index 0000000..905a15d
--- /dev/null
+++ b/build_rmr.sh
@@ -0,0 +1,23 @@
+#!/usr/bin/env ksh
+
+#	Mnemonic:	rmr_build.sh
+#	Abstract:	This will pull RMR from the repo, build and install. This
+#				is en lieu of using wget to fetch the RMR package from some
+#				repo and installing it.  The package method is preferred
+#				but if that breaks this can be used in place of it.
+
+rmr_ver=${1:-3.6.2}
+
+# assume that we're in the proper directory
+set -e
+git clone "https://gerrit.o-ran-sc.org/r/ric-plt/lib/rmr"
+
+cd rmr
+git checkout $ver
+mkdir .build
+cd .build
+cmake .. -DDEV_PKG=1 -DPACK_EXTERNALS=1
+make install
+cmake .. -DDEV_PKG=0
+make install
+